Photocam

- Main Page
- Related Pages
- Data Structures
- Files
- Examples

Typedefs | Enumerations | Functions
Photocam

## Typedefs
typedef struct _Elm_Photocam_Progress | Elm_Photocam_Progress
| Structure associated with smart callback 'download,progress'. More...
typedef struct _Elm_Photocam_Error | Elm_Photocam_Error
| Structre associated with smart callback 'download,error'. More...

## Enumerations
enum | Elm_Photocam_Zoom_Mode { ELM_PHOTOCAM_ZOOM_MODE_MANUAL = 0, ELM_PHOTOCAM_ZOOM_MODE_AUTO_FIT, ELM_PHOTOCAM_ZOOM_MODE_AUTO_FILL, ELM_PHOTOCAM_ZOOM_MODE_AUTO_FIT_IN }
| Types of zoom available. More...

## Functions
EINA_DEPRECATED void | elm_photocam_bounce_set (Evas_Object *obj, Eina_Bool h_bounce, Eina_Bool v_bounce)
| Set the photocam scrolling bouncing. More...
EINA_DEPRECATED void | elm_photocam_bounce_get (const Evas_Object *obj, Eina_Bool *h_bounce, Eina_Bool *v_bounce)
| Get the photocam scrolling bouncing. More...
Evas_Object * | elm_photocam_add (Evas_Object *parent)
| Add a new Photocam object. More...
void | elm_photocam_image_region_bring_in (Evas_Object *obj, int x, int y, int w, int h)
| Bring in the viewed portion of the image. More...
Evas_Load_Error | elm_photocam_file_set (Evas_Object *obj, const char *file)
| Set the photo file to be shown. More...
const char * | elm_photocam_file_get (const Evas_Object *obj)
| Returns the path of the current image file. More...

## Detailed Description

Photocam is a widget meant specifically for displaying high-resolution digital camera photos, giving speedy feedback (fast load), zooming and panning as well as fitting logic, all with low memory footprint. It is entirely focused on jpeg images, and takes advantage of properties of the jpeg format (via Evas loader features in the jpeg loader).

Signals that you can add callbacks for are:

- `"clicked"` - This is called when a user has clicked the photo without dragging around.
- `"press"` - This is called when a user has pressed down on the photo.
- `"longpressed"` - This is called when a user has pressed down on the photo for a long time without dragging around.
- `"clicked,double"` - This is called when a user has double-clicked the photo.
- `"load"` - Photo load begins.
- `"loaded"` - This is called when the image file load is complete for the first view (low resolution blurry version).
- `"load,detail"` - Photo detailed data load begins.
- `"loaded,detail"` - This is called when the image file load is complete for the detailed image data (full resolution needed).
- `"zoom,start"` - Zoom animation started.
- `"zoom,stop"` - Zoom animation stopped.
- `"zoom,change"` - Zoom changed when using an auto zoom mode.
- `"scroll"` - the content has been scrolled (moved)
- `"scroll,anim,start"` - scrolling animation has started
- `"scroll,anim,stop"` - scrolling animation has stopped
- `"scroll,drag,start"` - dragging the contents around has started
- `"scroll,drag,stop"` - dragging the contents around has stopped
- `"focused"` - When the photocam has received focus. (since 1.8)
- `"unfocused"` - When the photocam has lost focus. (since 1.8)

This widget implements the elm-scrollable-interface interface, so that all (non-deprecated) functions for the base Scroller widget also work for photocam objects.

Some calls on the photocam's API are marked as deprecated, as they just wrap the scrollable widgets counterpart functions. Use the ones we point you to, for each case of deprecation here, instead – eventually the deprecated ones will be discarded (next major release).

Photocam example shows the API in action.

## Typedef Documentation

typedef struct _Elm_Photocam_Error Elm_Photocam_Error

Structre associated with smart callback 'download,error'.

Since
  1.8

typedef struct _Elm_Photocam_Progress Elm_Photocam_Progress

Structure associated with smart callback 'download,progress'.

Since
  1.8

## Enumeration Type Documentation

enum Elm_Photocam_Zoom_Mode

Types of zoom available.

Enumerator
ELM_PHOTOCAM_ZOOM_MODE_MANUAL | Zoom controlled normally by elm_photocam_zoom_set.
ELM_PHOTOCAM_ZOOM_MODE_AUTO_FIT | Zoom until photo fits in photocam.
ELM_PHOTOCAM_ZOOM_MODE_AUTO_FILL | Zoom until photo fills photocam.
ELM_PHOTOCAM_ZOOM_MODE_AUTO_FIT_IN | Zoom in until photo fits in photocam.

## Function Documentation

Evas_Object* elm_photocam_add | ( | Evas_Object * | parent | ) |

Add a new Photocam object.

Parameters

  parent | The parent object

Returns
  The new object or NULL if it cannot be created

EINA_DEPRECATED void elm_photocam_bounce_get | ( | const Evas_Object * | obj,
|  | Eina_Bool * | h_bounce,
|  | Eina_Bool * | v_bounce
| ) |  |

Get the photocam scrolling bouncing.

Parameters

  obj | The photocam object
  h_bounce | horizontal bouncing
  v_bounce | vertical bouncing

See also
  elm_photocam_bounce_set()

Deprecated:
  Use elm_scroller_bounce_get() instead.

EINA_DEPRECATED void elm_photocam_bounce_set | ( | Evas_Object * | obj,
|  | Eina_Bool | h_bounce,
|  | Eina_Bool | v_bounce
| ) |  |

Set the photocam scrolling bouncing.

Parameters

  obj | The photocam object
  h_bounce | set this to `EINA_TRUE` for horizontal bouncing
  v_bounce | set this to `EINA_TRUE` for vertical bouncing

Deprecated:
  Use elm_scroller_bounce_set() instead.

const char* elm_photocam_file_get | ( | const Evas_Object * | obj | ) |

Returns the path of the current image file.

Returns
  Returns the path

See also
  elm_photocam_file_set()

Evas_Load_Error elm_photocam_file_set | ( | Evas_Object * | obj,
|  | const char * | file
| ) |  |

Set the photo file to be shown.

Returns
  The return error (see EVAS_LOAD_ERROR_NONE, EVAS_LOAD_ERROR_GENERIC etc.)

This sets (and shows) the specified file (with a relative or absolute path) and will return a load error (same error that evas_object_image_load_error_get() will return). The image will change and adjust its size at this point and begin a background load process for this photo that at some time in the future will be displayed at the full quality needed.

Parameters

  [in] | file | The photo file

Examples:
  photocam_example_01.c.

void elm_photocam_image_region_bring_in | ( | Evas_Object * | obj,
|  | int | x,
|  | int | y,
|  | int | w,
|  | int | h
| ) |  |

Bring in the viewed portion of the image.

Parameters

  obj | The photocam object
  x | X-coordinate of region in image original pixels
  y | Y-coordinate of region in image original pixels
  w | Width of region in image original pixels
  h | Height of region in image original pixels

This shows the region of the image using animation.